library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;


entity compteur_modulo6 is
    port (
        I_clk         : in  std_logic;
        I_rst         : in  std_logic;
        I_block       : in  std_logic;
        O_CounterMod6 : out std_logic_vector(2 downto 0)
        );

end compteur_modulo6;


architecture modulo6_a of compteur_modulo6 is

    signal SR_Counter : unsigned(2 downto 0);

begin

    mod6 : process (I_rst, I_clk)
    begin
        if I_rst = '1' then
            SR_Counter <= "000";
        elsif rising_edge(I_clk) then
            if I_block = '0' then
                if SR_Counter = "101" then
                    SR_Counter <= "000";
                else
                    SR_Counter <= SR_Counter + 1;
                end if;
            end if;
        end if;
    end process mod6;

    O_CounterMod6 <= std_logic_vector(SR_Counter);

end modulo6_a;
